# Generated from the Telepathy spec
"""
    Copyright (C) 2007 Collabora Limited
  

    This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
  
"""

import dbus.service


class ChannelTypeTubes(dbus.service.Interface):
    """\
      A "tube" is a mechanism for arbitrary data transfer. Currently, one kind
      of data transfer is specified, namely that of D-Bus messages. Each tube
      has a service name, which is a string specifying the kind of
      communication that takes place over it, and a dictionary of arbitrary
      parameters. Tube parameters are commonly used for bootstrap information
      such as usernames and passwords.

      The Tubes channel type may be requested for handles of type
      HANDLE_TYPE_CONTACT and HANDLE_TYPE_ROOM.
    """

    @dbus.service.method('org.freedesktop.Telepathy.Channel.Type.Tubes', in_signature='', out_signature='au')
    def GetAvailableTubeTypes(self):
        """
        """
        raise NotImplementedError
  
    @dbus.service.method('org.freedesktop.Telepathy.Channel.Type.Tubes', in_signature='', out_signature='a(uuusa{sv}u)')
    def ListTubes(self):
        """
        """
        raise NotImplementedError
  
    @dbus.service.method('org.freedesktop.Telepathy.Channel.Type.Tubes', in_signature='usa{sv}', out_signature='u')
    def OfferTube(self, type, service, parameters):
        """
        Offers a tube providing the service specified, over a tube of the
        specified type.
      
        """
        raise NotImplementedError
  
    @dbus.service.method('org.freedesktop.Telepathy.Channel.Type.Tubes', in_signature='u', out_signature='')
    def AcceptTube(self, id):
        """
        Accept a tube that's in the "local pending" state. The connection
        manager will attempt to open the tube. The tube remains in the
        "local pending" state until the TubeStateChanged signal is emitted.
      
        """
        raise NotImplementedError
  
    @dbus.service.method('org.freedesktop.Telepathy.Channel.Type.Tubes', in_signature='u', out_signature='')
    def CloseTube(self, id):
        """
        Close a tube.
      
        """
        raise NotImplementedError
  
    @dbus.service.method('org.freedesktop.Telepathy.Channel.Type.Tubes', in_signature='u', out_signature='s')
    def GetDBusServerAddress(self, id):
        """
        For a D-Bus tube, return a string describing the address of the
        private bus.
      
        """
        raise NotImplementedError
  
    @dbus.service.method('org.freedesktop.Telepathy.Channel.Type.Tubes', in_signature='u', out_signature='a(us)')
    def GetDBusNames(self, id):
        """
        For a D-Bus tube, obtain a mapping between contact handles and their
        unique bus names on this tube.
      
        """
        raise NotImplementedError
  
    @dbus.service.signal('org.freedesktop.Telepathy.Channel.Type.Tubes', signature='uuusa{sv}u')
    def NewTube(self, id, initiator, type, service, parameters, state):
        """
        Emitted when a tube is created.
      
        """
        pass
  
    @dbus.service.signal('org.freedesktop.Telepathy.Channel.Type.Tubes', signature='uu')
    def TubeStateChanged(self, id, state):
        """
        Emitted when the state of a tube changes.
      
        """
        pass
  
    @dbus.service.signal('org.freedesktop.Telepathy.Channel.Type.Tubes', signature='u')
    def TubeClosed(self, id):
        """
       Emitted when a tube has been closed. The ID of a closed tube is no
       longer valid. The ID may later be reused for a new tube.
      
        """
        pass
  
    @dbus.service.signal('org.freedesktop.Telepathy.Channel.Type.Tubes', signature='ua(us)au')
    def DBusNamesChanged(self, id, added, removed):
        """
        Emitted on a D-Bus tube when a participant opens or closes the tube.
      
        """
        pass
  